#pragma semicolon 1
#pragma newdecls required

bool
	bEnable,
	bMode,
	bType;

public Plugin myinfo =
{
	name		= "Show Damage [Multi methods]",
	version		= "2.0.3",
	description	= "Show damage in hint message, HUD and Particle",
	author		= "TheBΦ$$♚#2967 (rewritten by Grey83)",
	url			= "http://sourcemod.net"
};

public void OnPluginStart()
{
	LoadTranslations("Simple_Show_Damage.phrases");

	ConVar cvar;
	cvar = CreateConVar("sm_show_damage_enable", "1", "Enable/Disable plugin?", _, true, _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_Enable);
	bEnable = cvar.BoolValue;

	cvar = CreateConVar("sm_show_damage_type", "0", "0 = Показать повреждение в сообщении подсказки\n1 = Показать повреждение в сообщении HUD", _, true, _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_Type);
	bType = cvar.BoolValue;

	cvar = CreateConVar("sm_show_damage_mode", "1", "0 = Показать ущерб только жертве\n1 = Показать ущерб и оставшееся здоровье жертвы", _, true, _, true, 2.0);
	cvar.AddChangeHook(CVarChanged_Mode);
	bMode = cvar.BoolValue;

	HookEvent("player_hurt", Event_PlayerHurt, EventHookMode_Pre);
	AutoExecConfig(true, "Simple_Show_Damage");
}

public void CVarChanged_Enable(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	bEnable = cvar.BoolValue;
}

public void CVarChanged_Type(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	bType = cvar.BoolValue;
}

public void CVarChanged_Mode(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	bMode = cvar.BoolValue;
}

public void Event_PlayerHurt(Event event, const char[] name, bool dontBroadcast)
{
	if(!bEnable)
		return;

	static int victim, attacker, health, dmg;
	if(!(attacker = GetClientOfUserId(event.GetInt("attacker"))) || !(victim = GetClientOfUserId(event.GetInt("userid")))
	|| attacker == victim)
		return;

	health = event.GetInt("health");
	dmg = event.GetInt("dmg_health");

	switch(bType)
	{
		case 0:
		{
			//if(!bMode) PrintHintText(attacker, "%t %i %t %N", "Damage Giver", dmg, "Damage Taker", victim);
			//else PrintHintText(attacker, "%t %t %N\n %t %i", "Damage Giver", dmg, "Damage Taker", victim, "Health Remaining", health);
			
			if(!bMode) PrintHintText(attacker, "%t %d %t %N", "Damage Giver", dmg, "Damage Taker", victim);
			else PrintHintText(attacker, "%d \n %d", dmg, health);
		}
		case 1:
		{
			if(!bMode)
			{
				if(health > 50)
					SetHudTextParams(-1.0, 0.45, 1.3, 0, 253, 30, 200, 1);	// green
				else if(health > 20)
					SetHudTextParams(-1.0, 0.45, 1.3, 253, 229, 0, 200, 1);	// yellow
				else SetHudTextParams(-1.0, 0.45, 1.3, 255, 0, 0, 200, 1);	// red
				ShowHudText(attacker, 1, "%i", dmg);
			}
			else
			{
				if(health > 50)
					SetHudTextParams(0.43, 0.45, 1.3, 0, 253, 30, 200, 1);	// green
				else if(health > 20)
					SetHudTextParams(0.43, 0.45, 1.3, 253, 229, 0, 200, 1);	// yellow
				else SetHudTextParams(0.43, 0.45, 1.3, 255, 0, 0, 200, 1);	// red
				ShowHudText(attacker, 2, "%i", health);

				SetHudTextParams(0.57, 0.45, 1.3, 255, 255, 255, 200, 1);	// white
				ShowHudText(attacker, 1, "%i", dmg);
			}
		}
	}
}